"use strict";
{
    self.C3.Plugins.Sparsha_External_Image.Acts = {
        async LoadUrl(url, id, save)
        {
            var self = this;
            var oReq = new XMLHttpRequest();
            await oReq.open("GET", url, true);
            oReq.responseType = "blob";
            oReq.onload = function(oEvent)
            {
                if (oReq.response)
                {
                    //self.myBlob = oReq.response;
                    createImageBitmap(oReq.response).then(response => {
                        self.myID = id;
                        self.myObjName = self._objectClass._name;
                        globalThis.Sparsha_RemoteImageBitmap[self.myObjName][self.myID] = response;
                        self.myW = response.width;
                        self.myH = response.height;
                        self.isLoaded = true;
                        self.isNew = true;
                        self._runtime.UpdateRender();

                        if (save)
                        {
                            var reader = new FileReader();
                            reader.readAsDataURL(oReq.response);
                            reader.onloadend = function()
                            {
                                //self.mybase64 = reader.result;
                                var options_DOM = {
                                    "action": "setlocal",
                                    "blob_text": reader.result,
                                    "blob_key": "ExtImg-" + self.myObjName + self.myID,
                                };
                                self.PostToDOM("doAction", options_DOM);
                                self.Trigger(self.PluginCnds.OnSaved);
                            }
                            /*oReq.response.text().then(Blobtext => {
                        var options_DOM = {
                            "action": "setlocal",
                            "blob_text": Blobtext,
                            "blob_type": oReq.response.type,
                            "blob_key": "ExtImg-" + self.myObjName + self.myID,
                        };
                        self.PostToDOM("doAction", options_DOM);
                    });*/
                        }
                        self.Trigger(self.PluginCnds.OnLoaded);
                    })
                }
            };
            oReq.onerror = function()
            {
                self.Trigger(self.PluginCnds.OnError);
            }
            oReq.send();
        },

        LoadIID(id)
        {
            var self = this;
            self.myObjName = self._objectClass._name;
            self.myID = id;
            self.isLoaded = true;
            self.isNew = true;
            self._runtime.UpdateRender();
        },

        DestroyData(id)
        {
            delete globalThis.Sparsha_RemoteImageBitmap[this._objectClass._name][id];
        },

        DestroyAll()
        {
            delete globalThis.Sparsha_RemoteImageBitmap[this._objectClass._name];
        },

        LoadObject(obj, id)
        {
            var self = this;
            self.myObjName = obj._name;
            self.myID = id;
            self.isLoaded = true;
            self.isNew = true;
            self._runtime.UpdateRender();
        },

        LoadLocalstorage(obj, id)
        {
            var self = this;
            var options_DOM = {
                "action": "getlocal",
                "obj_name": obj._name,
                "myObj": self._objectClass._name,
                "img_id": id,
            };
            self.PostToDOM("doAction", options_DOM);
            //self._inst._runtime.UpdateRender();
            //self.Trigger(self.PluginCnds.OnLoaded);
        },

        DestroyId(obj, id)
        {
            delete globalThis.Sparsha_RemoteImageBitmap[obj._name][id];
        },

        DestroyObject(obj)
        {
            delete globalThis.Sparsha_RemoteImageBitmap[obj._name];
        },

        DeleteLocalstorage(obj, id)
        {
            var self = this;
            var options_DOM = {
                "action": "deletelocal",
                "blob_key": "ExtImg-" + obj._name + id,
            };
            self.PostToDOM("doAction", options_DOM);
        },

        PasteStorage()
        {
            var self = this;
            self.myObjName = self._objectClass._name;
            var res = globalThis.Sparsha_REMLocalStorage[self.myObjName];
            console.log(res);
            self.myID = res["img_id"];
            globalThis.Sparsha_RemoteImageBitmap[self.myObjName][self.myID] = res["response"];
            self.myW = res["response"]["width"];
            self.myH = res["response"]["height"];
            self.isLoaded = true;
            self.isNew = true;
            delete globalThis.Sparsha_REMLocalStorage[self.myObjName];
            self._runtime.UpdateRender();
            self.Trigger(self.PluginCnds.OnLoaded);
        }
    };
}